| "aux" stack words | enhanced from Reva |
|
| Author: Bob Armstrong / www.CoSy.com
| Reva's license terms also apply to this file.

cr ." | CSauxstack > | "
context: ~CSauxstack ~CSauxstack

| \/ | same as | C:\4thCoSy\lib\util\auxstack
1024 stack: (aux)
 
: >aux (aux) push ;
: >aux> dup >aux ;
: aux@ (aux) peek ;
: aux> (aux) pop ;
 
: aux# ( -- int ) (aux) dup @ swap - cell / ;
| /\ | same as | C:\4thCoSy\lib\util\auxstack



: >auxx aux> swap >aux >aux ;	| like ' tuck for aux stack
: >auxx> dup >auxx ;
: auxx@ (aux) @ cell- @ ;		| like ' over for aux stack .
: auxx> aux> aux> swap >aux ;	| like ' nip  for aux stack
 
: 2>aux >aux >aux ;		 : 2aux> aux> aux> ;  
 
: auxdrop aux> drop ;
: aux+ aux@ + ;  
 
: s>x ( n -- n items dropped from stack ) dup >r 0do >aux loop r> >aux ;
|  move n items from stk > aux & store n at new aux stk 0 point 
 |  sp (aux) @ rot dup >r move 		| to optimize 
 
: x>s ( -- n items restored from aux stack ) 
   aux> 0do aux> loop ;


| : auxfence+ ( n -- ) (aux) dup @ dup @ 3 pick	| add n cells to the stack frame 
|   cells rot + swap 3 pick +  over ! swap ! drop ;
| Note these locals are not protected against overwriting
|  by called fns . To protect them , use  auxfence+ to add more
| cells to the stack frame . Note then , of course your indexing
| of parameters will change by the number of cells added .


| ----------------------------------------------------------------- |

| 				"p-stack" lite waet locals .

|  Extended for use as "locals" . BA 20060302 20061119  
|  Replacing use of aux stk w special purpose "p"arameter stack . 
| s>p  moves n items from stack to pstk . 
| 1 xi  returns address of first ( deepest ) item moved , 2 xi ... etc .
| 0 xi @ returns number of "locals" .
| -1 xi  , -2 xi , etc can be used as additional locals
| xreset  resets the stack pointer to its previous state . 

1024 stack: pstk

: >p pstk push ;
: >p> dup >p ;
: p@ pstk peek ;
: p> pstk pop ;

: s>p ( . . . n -- n items dropped from stack )
   dup >r 0do pstk push loop r> pstk push ;
|  move n items from stk > pstk & store n at new pstk 0 point 
	|  sp (aux) @ rot dup >r move 		| ought optimize 

| : p>s ( -- n items restored from p stack ) 
|   pstk pop 0do pstk pop loop ;
 
: xi ( i -- adr ) pstk @ swap cells - ;	| return adr for ith item in p stk  

: x@ xi @ ;
: x! xi ! ; 

: LA  1 xi ;	: RA  2 xi ;	| Shorthand for dyadic fns .
: L@  1 x@ ;	: R@  2 x@ ;
: L!  1 x! ;	: R!  2 x! ;

: LR@ 1 x@ 2 x@ ;

: xreset pstk dup @ dup @ 1+ cells - swap ! ; 
  
| hide (aux)


." |\\/| StackFrames |\\/| "  
| The above does not answer the need for recursive stack frames .
| This is implementing the notion in George B. Lyons : Stack Frames and Local Variables :  http://www.forth.com/archive/jfar/vol3/no1/article3.pdf

s0 s0 ! 	| relies for stopping on s0 being set to its own address .

: esi@ inline{ 8D 76 FC   89 F0 } ; | lea esi,[esi-04]   mov eax, esi 
  | esi contains the current stack ptr , ie the address of t .

: esi! asm{ mov esi, eax } ; 

s0 variable, SFptr 		| initialize StackFrame pointer 

| : reset prior reset s0 cell- SFptr ! ;

: SF+ | puts previous esi on the stack and saves current 
	esi@ SFptr xchg ;

: SFx cells SFptr @ cell- + ;
 
: SF@ SFx @ ;  		: SF! SFx ! ;  

: SF- | restores previous stack pointer . 
	esi@ s0 <> 0;drop 0 SF@ dup @ $.s cr SFptr !  esi! ; 


." |/\\| StackFrames |/\\| "  
exit~ with~ ~CSauxstack

." | < CSauxstack | "

